﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SingletonPattern
{
    class Program
    {
        static void Main(string[] args)
        {
            

            License.GetInstance().CheckLicense(20110925);
            GcManager.instance.FreeMemory();
            GcManager.instance.FreeObject();

            Console.ReadLine();
        }
    }

    //双检锁的单例模式
    public class License
    {
        private static License instance ;
        private static object _lock = new object();
        private License() { }
        public static License GetInstance()
        {
            if (instance == null)
            {
                lock (_lock)
                {
                    if (instance == null)
                    {
                        instance = new License();
                    }
                }
            }
            return instance;
        }
        public void CheckLicense(int code)
        {
            if (code == 20110925)
                Console.WriteLine("通过了License验证");
            else
                Console.WriteLine("没有通过License验证"); 
        }
    }

    //饿汉单例模式
    public class GcManager
    {
        public static readonly GcManager instance = new GcManager();
        private GcManager() { }
        public void FreeMemory()
        {
            GC.Collect();
            Console.WriteLine("开始释放内存！");
        }
        public void FreeObject()
        {
            Console.WriteLine("开始释放对象！");
        }
    }
}
